'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _overrides = require('../helpers/overrides');

var _utils = require('./utils');

var _constants = require('./constants');

var _styledComponents = require('./styled-components');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               Copyright (c) 2018 Uber Technologies, Inc.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               */


var NullComponent = function NullComponent() {
  return null;
};

var BaseInput = function (_React$Component) {
  _inherits(BaseInput, _React$Component);

  function BaseInput() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, BaseInput);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = BaseInput.__proto__ || Object.getPrototypeOf(BaseInput)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      isFocused: _this.props.autoFocus || false
    }, _this.onFocus = function (e) {
      _this.setState({ isFocused: true });
      _this.props.onFocus(e);
    }, _this.onBlur = function (e) {
      _this.setState({ isFocused: false });
      _this.props.onBlur(e);
    }, _this.getInputProps = function () {
      var _this$props = _this.props,
          disabled = _this$props.disabled,
          error = _this$props.error,
          id = _this$props.id,
          name = _this$props.name,
          inputRef = _this$props.inputRef,
          onChange = _this$props.onChange,
          placeholder = _this$props.placeholder,
          required = _this$props.required,
          type = _this$props.type,
          value = _this$props.value,
          rows = _this$props.rows;

      return _extends({
        $ref: inputRef,
        'aria-invalid': !!error,
        'aria-required': required,
        disabled: disabled,
        id: id,
        name: name,
        onChange: onChange,
        onFocus: _this.onFocus,
        onBlur: _this.onBlur,
        placeholder: placeholder,
        type: type,
        value: value
      }, type === _constants.CUSTOM_INPUT_TYPE.textarea ? { rows: rows } : {});
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(BaseInput, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props,
          autoFocus = _props.autoFocus,
          inputRef = _props.inputRef;

      if (autoFocus && inputRef.current) {
        inputRef.current.focus();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          value = _props2.value,
          type = _props2.type,
          _props2$overrides = _props2.overrides,
          InputContainerOverride = _props2$overrides.InputContainer,
          InputOverride = _props2$overrides.Input,
          BeforeOverride = _props2$overrides.Before,
          AfterOverride = _props2$overrides.After;


      var sharedProps = (0, _utils.getSharedProps)(this.props, this.state);

      var _getOverrides = (0, _overrides.getOverrides)(InputContainerOverride, _styledComponents.InputContainer),
          _getOverrides2 = _slicedToArray(_getOverrides, 2),
          InputContainer = _getOverrides2[0],
          inputContainerProps = _getOverrides2[1];

      var _getOverrides3 = (0, _overrides.getOverrides)(InputOverride, _styledComponents.Input),
          _getOverrides4 = _slicedToArray(_getOverrides3, 2),
          Input = _getOverrides4[0],
          inputProps = _getOverrides4[1];

      var _getOverrides5 = (0, _overrides.getOverrides)(BeforeOverride, NullComponent),
          _getOverrides6 = _slicedToArray(_getOverrides5, 2),
          Before = _getOverrides6[0],
          beforeProps = _getOverrides6[1];

      var _getOverrides7 = (0, _overrides.getOverrides)(AfterOverride, NullComponent),
          _getOverrides8 = _slicedToArray(_getOverrides7, 2),
          After = _getOverrides8[0],
          afterProps = _getOverrides8[1];

      return React.createElement(
        InputContainer,
        _extends({}, sharedProps, inputContainerProps),
        React.createElement(Before, _extends({}, sharedProps, beforeProps)),
        React.createElement(
          Input,
          _extends({}, sharedProps, this.getInputProps(), inputProps),
          type === _constants.CUSTOM_INPUT_TYPE.textarea ? value : null
        ),
        React.createElement(After, _extends({}, sharedProps, afterProps))
      );
    }
  }]);

  return BaseInput;
}(React.Component);

BaseInput.defaultProps = {
  adjoined: _constants.ADJOINED.none,
  autoFocus: false,
  disabled: false,
  error: false,
  name: '',
  inputRef: React.createRef(),
  onBlur: function onBlur() {},
  onChange: function onChange() {},
  onFocus: function onFocus() {},
  overrides: {},
  placeholder: '',
  required: false,
  size: _constants.SIZE.default,
  type: 'text'
};
exports.default = BaseInput;